/* Nefarious IRCu functions
 *
 * (C) 2005 Neil Spierling <sirvulcan@gmail.com>
 *
 * Please read COPYING and README for further details.
 *
 * Based on the original code of Epona by Lara.
 * Based on the original code of Services by Andy Church.
 *
 *
 */

#define UMODE_a 0x00000001  /* Admin status */
#define UMODE_d 0x00000080  /* See bot and drone flooding notices */
#define UMODE_f 0x00000100  /* Client connection/quit notices */
#define UMODE_g 0x00000200  /* See debugging notices */
#define UMODE_h 0x00000400  /* See I: line full notices */
#define UMODE_i 0x00000800  /* Server Side Ignore */
#define UMODE_k 0x00001000  /* Not shown in NAMES or WHO unless you share a channel */
#define UMODE_n 0x00002000  /* See server generated KILL messages */
#define UMODE_o 0x00004000  /* See LOCOPS messages */
#define UMODE_r 0x00008000  /* See client nick changes */
#define UMODE_s 0x00010000  /* See client nick changes */
#define UMODE_w 0x00020000  /* Operator status */
#define UMODE_x 0x00040000  /* See rejected client notices */
#define UMODE_B 0x00080000  /* See general server notices */
#define UMODE_I 0x00100000  /* See unauthorized client notices */
#define UMODE_R 0x00200000  /* See server generated WALLOPS */
#define UMODE_W 0x00400000  /* See remote server connection and split notices */
#define UMODE_X 0x00800000  /* See client nick changes */

#define CMODE_a 0x00000001     /* Invite only */
#define CMODE_c 0x00000002     /* Users without +v/h/o cannot send text to the channel */
#define CMODE_i 0x00000004     /* Users must be in the channel to send text to it */
#define CMODE_k 0x00000008     /* Private is obsolete, this now restricts KNOCK */
#define CMODE_l 0x00000010     /* The channel does not show up on NAMES or LIST */
#define CMODE_m 0x00000020     /* Only chanops can change the topic */
#define CMODE_n 0x00000040     /* Key/password for the channel. */
#define CMODE_p 0x00000080     /* Limit the number of users in a channel */
#define CMODE_r 0x00000400
#define CMODE_s 0x00000800     /* Anonymous ops, chanops are hidden */
#define CMODE_t 0x00001000
#define CMODE_v 0x00002000
#define CMODE_z 0x00004000
#define CMODE_C 0x00008000
#define CMODE_L 0x00010000
#define CMODE_M 0x00020000
#define CMODE_N 0x00040000
#define CMODE_O 0x00080000
#define CMODE_Q 0x00100000
#define CMODE_S 0x00200000
#define CMODE_T 0x00400000
#define CMODE_Z 0x00800000

#define DEFAULT_MLOCK CMODE_n | CMODE_t

void nefarious_set_umode(User * user, int ac, char **av);
void nefarious_cmd_svsnoop(char *server, int set);
void nefarious_cmd_remove_akill(char *user, char *host);
void nefarious_cmd_topic(char *whosets, char *chan, char *whosetit, char *topic, time_t when);
void nefarious_cmd_vhost_off(User * u);
void nefarious_cmd_akill(char *user, char *host, char *who, time_t when,time_t expires, char *reason);
void nefarious_cmd_svskill(char *source, char *user, char *buf);
void nefarious_cmd_svsmode(User * u, int ac, char **av);
void nefarious_cmd_372(char *source, char *msg);
void nefarious_cmd_372_error(char *source);
void nefarious_cmd_375(char *source);
void nefarious_cmd_376(char *source);
void nefarious_cmd_nick(char *nick, char *name, char *modes);
void nefarious_cmd_guest_nick(char *nick, char *user, char *host, char *real, char *modes);
void nefarious_cmd_mode(char *source, char *dest, char *buf);
void nefarious_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void nefarious_cmd_kick(char *source, char *chan, char *user, char *buf);
void nefarious_cmd_notice_ops(char *source, char *dest, char *buf);
void nefarious_cmd_notice(char *source, char *dest, char *buf);
void nefarious_cmd_notice2(char *source, char *dest, char *msg);
void nefarious_cmd_privmsg(char *source, char *dest, char *buf);
void nefarious_cmd_privmsg2(char *source, char *dest, char *msg);
void nefarious_cmd_serv_notice(char *source, char *dest, char *msg);
void nefarious_cmd_serv_privmsg(char *source, char *dest, char *msg);
void nefarious_cmd_bot_chan_mode(char *nick, char *chan);
void nefarious_cmd_351(char *source);
void nefarious_cmd_quit(char *source, char *buf);
void nefarious_cmd_pong(char *servname, char *who);
void nefarious_cmd_join(char *user, char *channel, time_t chantime);
void nefarious_cmd_unsqline(char *user);
void nefarious_cmd_invite(char *source, char *chan, char *nick);
void nefarious_cmd_part(char *nick, char *chan, char *buf);
void nefarious_cmd_391(char *source, char *timestr);
void nefarious_cmd_250(char *buf);
void nefarious_cmd_307(char *buf);
void nefarious_cmd_311(char *buf);
void nefarious_cmd_312(char *buf);
void nefarious_cmd_317(char *buf);
void nefarious_cmd_219(char *source, char *letter);
void nefarious_cmd_401(char *source, char *who);
void nefarious_cmd_318(char *source, char *who);
void nefarious_cmd_242(char *buf);
void nefarious_cmd_243(char *buf);
void nefarious_cmd_211(char *buf);
void nefarious_cmd_global(char *source, char *buf);
void nefarious_cmd_global_legacy(char *source, char *fmt);
void nefarious_cmd_sqline(char *mask, char *reason);
void nefarious_cmd_squit(char *servname, char *message);
void nefarious_cmd_svso(char *source, char *nick, char *flag);
void nefarious_cmd_chg_nick(char *oldnick, char *newnick);
void nefarious_cmd_svsnick(char *source, char *guest, time_t when);
void nefarious_cmd_vhost_on(char *nick, char *vIdent, char *vhost);
void nefarious_cmd_connect();
void nefarious_cmd_svshold(char *nick);
void nefarious_cmd_release_svshold(char *nick);
void nefarious_cmd_unsgline(char *mask);
void nefarious_cmd_unszline(char *mask);
void nefarious_cmd_szline(char *mask, char *reason, char *whom);
void nefarious_cmd_sgline(char *mask, char *reason);
void nefarious_cmd_unban(char *name, char *nick);
void nefarious_cmd_svsmode_chan(char *name, char *mode, char *nick);
void nefarious_cmd_svid_umode(char *nick, time_t ts);
void nefarious_cmd_nc_change(User * u);
void nefarious_cmd_svid_umode2(User * u, char *ts);
void nefarious_cmd_svid_umode3(User * u, char *ts);
void nefarious_cmd_eob();
int nefarious_flood_mode_check(char *value);
void nefarious_cmd_jupe(char *jserver, char *who, char *reason);
int nefarious_valid_nick(char *nick);
void nefarious_cmd_ctcp(char *source, char *dest, char *buf);
void nefarious_cmd_account(User * u);
void nefarious_cmd_svid_umode(char *nick, time_t ts);
void nefarious_cmd_svid_umode2(User * u, char *ts);
void nefarious_cmd_svid_umode3(User * u, char *ts);
